


typedef struct celldata_struct
	{
	Point3  **p;
	int		*count;
	float	*weight;
	float	*str;
	float	*u;

	int	*isMirror;

//	int customPointCount;
//	Point3  *customPoints;
}  CellDataStruct;



typedef struct custompointsdata_struct
	{
	Point3  *p;
}  CustomPointDataStruct;



class CellClass
{
public:
	Tab<int>  whichNode;
	Tab<int>  whichPoint;
};

class CustomPointGatherer
{
public:
	CustomPointGatherer()
		{
		width = 0;
		upperLeft = Point3 (0.0f,0.0f,0.0f);
		}
	~CustomPointGatherer()
		{
		FreeCells(TRUE);
		}

	CreateCells(int width, Box3 box);
	FreeCells(BOOL nukeCustomPoints = FALSE);

	ClearWeights();


	SetNumberNodes(int ct);
	SetCount(int index, int ct);
	Add(Point3 *p, int index, int nodeIndex);

//	SetCustomPoints(int whichNode,int ct, Point3 *points);
	
	float LineToPoint(Point3 p1, Point3 l1, Point3 l2, float &u);

	AddWeightFromSegment(Point3 a, float radiusA, float strA,
						 Point3 b, float radiusB, float strB, ICurve *pCurve, BOOL additive, BOOL isMirror,
						 float currentLength);

	float *GetWeights(int whichNode,int &ct); 
	float *GetStr(int whichNode,int &ct);
	float *GetU(int whichNode,int &ct);
	int *GetIsMirror(int whichNode,int &ct);

	

	BitArray *GetHits(int whichNode);

	void BuildGatherData(int cellSize, Point3 *points, int count);

	

private:

	Tab<int>		cellElementCount;

	Tab<CellDataStruct> cellData;

	Tab<CellClass*> CellDataXY;
	Tab<CellClass *> CellDataYZ;
	Tab<CellClass *> CellDataXZ;

	Tab<BitArray*> pointGatherHitVerts;

	int width;


	Point3 upperLeft;
	float xOffset, yOffset,zOffset;


	
};
