#include "PainterTextureSample.h"


inline UWORD FlToWord(float r) {
	return (UWORD)(65535.0f*r);
	}


InkStroker::InkStroker() 
{


//	bm = NULL;
//	holdbm = NULL;

}
InkStroker::~InkStroker() 
{
}	

InkStroker::HoldBitmap()
{
//	if ((bm) && (holdbm))
//		holdbm->CopyImage(bm,COPY_IMAGE_CROP,0);
}

InkStroker::RestoreBitmap()
{
//	if ((bm) && (holdbm))
//		bm->CopyImage(holdbm,COPY_IMAGE_CROP,0);
}



InkStroker::Fill(Bitmap *source, Point3 color,
		int *indexMapper, int ct)
{
	if (source == NULL) return 0;
	if (indexMapper == NULL) return 0 ;
	if (ct == 0) return 0;

	int width = source->Width();
	int height = source->Height();
	
	BMM_Color_64 color64;
	color64.r = FlToWord(color.x);
	color64.g = FlToWord(color.y);
	color64.b = FlToWord(color.z);
	int *indexList = indexMapper;
	for (int i = 0; i < ct; i++)
		{
		int id = *indexList;
		int y = height - (id / width) -1;
		int x = id % width;
		source->PutPixels(x,y,1,&color64);
		indexList++;
		}


	return 1;
}

InkStroker::Fill(Point3 *source, int count, Point3 color)
{
	if (source == NULL) return 0;
	if (count == 0) return 0;

	
	BMM_Color_64 color64;
	color64.r = FlToWord(color.x);
	color64.g = FlToWord(color.y);
	color64.b = FlToWord(color.z);

	for (int i = 0; i < count; i++)
		{
		source[i] = color;
		}


	return 1;	
}


void InkStroker::ApplyStroke(Bitmap *bm, float *weights, float *str, int *indexMapper, int count,
							 Point3 color,
							 int gradientType,  float *v, Texmap * tex, float strokeLen)
{
	if (bm == NULL) return;
	if (indexMapper == NULL) return;
	if (count == 0) return;

	Tab<float> baseWeights;
	baseWeights.SetCount(count);

	float *addr = baseWeights.Addr(0);
	memset(addr,0,count*sizeof(float));

	int width = bm->Width();
	int height = bm->Height();

	int *indexList = indexMapper;

	BMM_Color_64 color64;
	color64.r = FlToWord(color.x);
	color64.g = FlToWord(color.y);
	color64.b = FlToWord(color.z);

	for (int i =0; i < count; i++)
		{
		if (*str > 0.0f)
			{
			int id = *indexList;

//			Point3 uvw = uvwList[i];
	//draw in the bitmap
			if (weights[i] > baseWeights[i])
				{
				baseWeights[i] = weights[i];
				BMM_Color_64 basebit;
				int y =  height - (id / width)-1;
				int x =  id % width;

				float baseAlpha, incAlpha;
				incAlpha = *str;
				baseAlpha = 1.0f - *str;
				bm->GetPixels(x,y,1,&basebit);

				if (gradientType == kNoGradient)
					{
					basebit.r = (basebit.r * baseAlpha) + (color64.r * incAlpha);
					basebit.g = (basebit.g * baseAlpha) + (color64.g * incAlpha);
					basebit.b = (basebit.b * baseAlpha) + (color64.b * incAlpha);
					bm->PutPixels(x,y,1,&basebit);
					}
				else 
					{
					sc.uvw.x = 0.0f;
					sc.uvw.y = 0.0f;
					sc.uvw.z = 0.0f;

					if (gradientType == kUGradient)
						sc.uvw.x = 1.0f - weights[i];
					else if (gradientType == kVGradient)
						sc.uvw.x = 1.0f-v[i]/strokeLen;
					else if (gradientType == kUVGradient)
						{
						sc.uvw.x = 1.0f - weights[i];
						sc.uvw.y = 1.0f - v[i]/strokeLen;
						}

					sc.pt = sc.uvw;
//DebugPrint("u %f v %f\n",sc.uvw.x,sc.uvw.y);

					if (tex)
						{

						AColor c;
						c  = tex->EvalColor(sc);
						color64.r = FlToWord(c.r);
						color64.g = FlToWord(c.g);
						color64.b = FlToWord(c.b);
						

						basebit.r = (basebit.r * baseAlpha) + (color64.r * incAlpha);
						basebit.g = (basebit.g * baseAlpha) + (color64.g * incAlpha);
						basebit.b = (basebit.b * baseAlpha) + (color64.b * incAlpha);
						bm->PutPixels(x,y,1,&basebit);
						}
					}

	
				}
			}
		str++;
		indexList++;
		}


}

void InkStroker::ApplyStroke(Point3 *bm, float *weights, float *str, int count, Point3 color,						
							 int gradientType,  float *v, Texmap * tex,float strokeLen)

{
	if (bm == NULL) return;
	if (count == 0) return;

	Tab<float> baseWeights;
	baseWeights.SetCount(count);

	float *addr = baseWeights.Addr(0);
	memset(addr,0,count*sizeof(float));





	for (int i =0; i < count; i++)
		{
		if (*str > 0.0f)
			{

//			Point3 uvw = uvwList[i];
	//draw in the bitmap
			if (weights[i] > baseWeights[i])
				{
				baseWeights[i] = weights[i];
				Point3 basebit;

				float baseAlpha, incAlpha;
				incAlpha = *str;
				baseAlpha = 1.0f - *str;
				basebit = bm[i];

				if (gradientType == kNoGradient)
					{
					basebit.x = (basebit.x * baseAlpha) + (color.x * incAlpha);
					basebit.y = (basebit.y * baseAlpha) + (color.y * incAlpha);
					basebit.z = (basebit.z * baseAlpha) + (color.z * incAlpha);
					bm[i] = basebit;
					}
				else 
					{
					sc.uvw.x = 0.0f;
					sc.uvw.y = 0.0f;
					sc.uvw.z = 0.0f;

					if (gradientType == kUGradient)
						sc.uvw.x = 1.0f - weights[i];
					else if (gradientType == kVGradient)
						sc.uvw.x = 1.0f - v[i]/strokeLen;
					else if (gradientType == kUVGradient)
						{
						sc.uvw.x = 1.0f - weights[i];
						sc.uvw.y = 1.0f - v[i]/strokeLen;
						}

					sc.pt = sc.uvw;

					if (tex)
						{

						AColor c;
						c  = tex->EvalColor(sc);

					
						basebit.x = (basebit.x * baseAlpha) + (c.r * incAlpha);
						basebit.y = (basebit.y * baseAlpha) + (c.g * incAlpha);
						basebit.z = (basebit.z * baseAlpha) + (c.b * incAlpha);
						bm[i] = basebit;
						}
					}

	
				}
			}
		str++;
		}

}
