/**********************************************************************
 *<
	FILE: PainterTextureSample.h

	DESCRIPTION:	Includes for Plugins

	CREATED BY:

	HISTORY:

 *>	Copyright (c) 2000, All Rights Reserved.
 **********************************************************************/

#ifndef __PAINTERTEXTURESAMPLE__H
#define __PAINTERTEXTURESAMPLE__H

#include "Max.h"
#include "resource.h"
#include "istdplug.h"
#include "iparamb2.h"
#include "iparamm2.h"


#include "iPainterInterface.h"

#include "stdmat.h"
#include "texutil.h"
#include "imtl.h"
#include "macrorec.h"
#include "CustomPointGatherer.h"



extern TCHAR *GetString(int id);

extern HINSTANCE hInstance;


#define PAINTERTEXTURESAMPLE_CLASS_ID	Class_ID(0x3e6aeb2b, 0x6d648522)
#define VCPAINTER_CLASS_ID	Class_ID(0x51bfdbbb, 0x7315221f)




class LightDescImp: public LightDesc {
	public:
	Point3 pos;
	Color col;
    BOOL Illuminate(ShadeContext& sc, Point3& normal, Color& color, Point3 &dir, float &dot_nl) {
		dir = Normalize(pos-sc.P());
		dot_nl = DotProd(normal,dir);
		color = col;
		return 1;		
		}
	};
class SCTex: public ShadeContext {
	public:
	float tiling;
	float scale;
	Color ambientLight;
	LightDescImp* lights[2];
	Point3 uvw,duvw,norm,view,pt,dpt;
	IPoint2 scrPos;
	TimeValue curTime;
	Renderer *GetRenderer() { return NULL; }
	BOOL 	  InMtlEditor() { return TRUE; }
	LightDesc* Light(int n) { return lights[n]; }
	int ProjType() { return 1;} // returns: 0: perspective, 1: parallel
	int FaceNumber() { return 0; }
	TimeValue CurTime() { return curTime; }
	Point3 Normal() { return norm; }  	// interpolated normal
	void SetNormal(Point3 p) { norm = p;} 	// for perturbing normal
	Point3 GNormal() { return norm;} 	// geometric (face) normal
	Point3 ReflectVector() { return Point3(0,0,1); }
	Point3 RefractVector(float ior) {return Point3(0,0,1);	}
    Point3 CamPos() { return Point3(0,0,0); }			// camera position
	Point3 V() { return view; }       	// Unit view vector: from camera towards P 
	void SetView(Point3 v) { view =v; }
	Point3 P();			// point to be shaded in camera space;
	Point3 DP();   		// deriv of P, relative to pixel, for AA
	Point3 PObj();					  	// point in obj coords
	Point3 DPObj();   	// deriv of PObj, rel to pixel, for AA
	Box3 ObjectBox(); 	 			 	// Object extents box in obj coords
	Point3 PObjRelBox();   				// Point rel to obj box [-1 .. +1 ] 
	Point3 DPObjRelBox();  				// Point rel to obj box [-1 .. +1 ] 
	Point3 UVW(int chan) { return uvw;	};
   	Point3 DUVW(int chan) {	return duvw;	}
	void DPdUVW(Point3 dP[3],int chan); 			// Bump vectors for UVW: in Camera space
	AColor EvalEnvironMap(Texmap *map, Point3 viewd) {
		AColor rcol;
        rcol.Black();
		return rcol;
		}

	void ScreenUV(Point2& uv, Point2 &duv); // screen coordinate
	IPoint2 SCTex::ScreenCoord() {return scrPos;}

	Point3 PointTo(const Point3& p, RefFrame ito) { return p; }
	Point3 PointFrom(const Point3& p, RefFrame ifrom) { return p; } 
	Point3 VectorTo(const Point3& p, RefFrame ito) { return p; } 
	Point3 VectorFrom(const Point3& p, RefFrame ifrom){ return p; } 
	void GetBGColor(Color &bgcol, Color& transp, BOOL fogBG=TRUE) {	}
	SCTex();
	void SetTiling(float t) { tiling = t; }
	};



#define NSUBTEX		1 // TODO: number of sub-textures supported by this plugin 
#define COORD_REF	0


#define PBLOCK_REF	1
//#define TEXOUT_REF	2

enum {	kNoGradient,
		kUGradient,
		kVGradient,
		kUVGradient = 4
 };


enum {	kPen,
		kLine,
		kRectangle,
		kCircle = 3
 };

class PainterTextureSample;

class VCPainter;

class PainterTextureSampleSampler: public MapSampler {
	PainterTextureSample	*tex;
	public:
		PainterTextureSampleSampler() { tex= NULL; }
		PainterTextureSampleSampler(PainterTextureSample *c) { tex= c; }
		void Set(PainterTextureSample *c) { tex = c; }
		AColor Sample(ShadeContext& sc, float u,float v);
		AColor SampleFilter(ShadeContext& sc, float u,float v, float du, float dv);
		float SampleMono(ShadeContext& sc, float u,float v);
		float SampleMonoFilter(ShadeContext& sc, float u,float v, float du, float dv);
	} ;


class InkStroker
	{

public:

//	Bitmap *bm;
//	Bitmap *holdbm;


	InkStroker();
	~InkStroker();

	HoldBitmap();
	RestoreBitmap();

//	InitializeBitmap(int width, Point3 color, Bitmap *source = NULL);

	SCTex sc;
// ink a line segment or spline	
	void ApplyStroke(Bitmap *bm, float *weights, float *str, int *indexList, int count, Point3 color,
					int gradientType,  float *v, Texmap * tex, float strokeLen);
	void ApplyStroke(Point3 *bm, float *weights, float *str, int count, Point3 color,
					int gradientType,  float *v, Texmap * tex, float strokeLen);


// fill whole mesh	
	Fill(Bitmap *source, Point3 color,
		int *indexMapper, int ct);	
	Fill(Point3 *source, int count, Point3 color);	



//fill poly
//	FillPoly();	

	

	};

class StrokeData
	{

	};

//class PaintTextureTestDlgProc : public ParamMap2UserDlgProc {
class PainterDlgProc : public ParamMap2UserDlgProc {
	public:

		

		PainterTextureSample *tex;
		VCPainter *mod;
		PainterDlgProc(PainterTextureSample *m) 
				{
				tex = m;
				pPainter = NULL;
				mod = NULL;
				iPaintButton = NULL;
				}

		PainterDlgProc(VCPainter *m) 
				{
				tex = NULL;
				mod = m;
				pPainter = NULL;
				iPaintButton = NULL;
				}

		~PainterDlgProc() ;


		BOOL DlgProc(TimeValue t,IParamMap2* map,HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam);
		void DeleteThis();

		void  InitUI(HWND hWnd);
		void  DestroyUI(HWND hWnd);

		void  PaintOptions();
		void  Paint();



		ICustButton		*iPaintButton;
		IPainterInterface_V5 *pPainter;
		HWND hwnd;

		int lagRate, lagCount;
		BOOL  StartStroke();
		//This is called as the user strokes across the mesh or screen with the mouse down
		BOOL  PaintStroke(
						  BOOL hit,
						  IPoint2 mousePos, 
						  Point3 worldPoint, Point3 worldNormal,
						  Point3 localPoint, Point3 localNormal,
						  Point3 bary,  int index,
						  BOOL shift, BOOL ctrl, BOOL alt, 
						  float radius, float str,
						  float pressure, INode *node,
						  BOOL mirrorOn,
						  Point3 worldMirrorPoint, Point3 worldMirrorNormal,
						  Point3 localMirrorPoint, Point3 localMirrorNormal
						  ) ;

		// This is called as the user ends a strokes when the users has it set to always update
		BOOL  EndStroke();

		// This is called as the user ends a strokes when the users has it set to update on mouse up only
		// the canvas gets a list of all points, normals etc instead of one at a time
		//		int ct - the number of elements in the following arrays
		//  <...> see paintstroke() these are identical except they are arrays of values
		BOOL  EndStroke(int ct, BOOL *hit, IPoint2 *mousePos, 
						  Point3 *worldPoint, Point3 *worldNormal,
						  Point3 *localPoint, Point3 *localNormal,
						  Point3 *bary,  int *index,
						  BOOL *shift, BOOL *ctrl, BOOL *alt, 
						  float *radius, float *str,
						  float *pressure, INode **node,
						  BOOL mirrorOn,
						  Point3 *worldMirrorPoint, Point3 *worldMirrorNormal,
						  Point3 *localMirrorPoint, Point3 *localMirrorNormal);

		// This is called as the user cancels a stroke by right clicking
		BOOL  CancelStroke();	
		BOOL  SystemEndPaintSession();

		void PainterDisplay(TimeValue t, ViewExp *vpt, int flags) ;

		void PaintLine(IPoint2 mousePosS,IPoint2 mousePosE, INode *node);
		void PaintRectangle(IPoint2 mousePosS,IPoint2 mousePosE, INode *node);

		void PaintCircle(IPoint2 mousePosS,IPoint2 mousePosE, INode *node);

		void PaintNode();


		float GetStrokeLen();

		void EnableUI(BOOL enable);

		int strokeType;
		int sampleRate;
		BOOL firstLineStroke;
		IPoint2 startLine, endLine;


	};

class PainterTextureDlgProc : public ParamMap2UserDlgProc 
	{
	public:

		

		PainterTextureSample *tex;
		PainterTextureDlgProc(PainterTextureSample *m) 
				{
				tex = m;
				}


		~PainterTextureDlgProc() {}


		BOOL DlgProc(TimeValue t,IParamMap2* map,HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam);
		void DeleteThis() { delete this;}
	};
	

class PaintVCDlgProc : public ParamMap2UserDlgProc {
	public:
		VCPainter *mod;
		PaintVCDlgProc(VCPainter *m) {mod = m;}
		BOOL DlgProc(TimeValue t,IParamMap2* map,HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam);
		void DeleteThis() { delete this;}
	};



class PainterTextureSample : public Texmap, public IPainterCanvasInterface_V5//, public  IPainterDlgProc  
	{
	public:

		enum { paintertexturesample_params };

		enum { paintertexturesample_bitmap,
				paintertexturesample_paint,
				paintertexturesample_advance
			};
//TODO: Add enums for various parameters
		enum { 
			pb_bitmap,  pb_color,
			pb_coords,
			pb_stroketype,
			pb_samplerate,
			pb_gradient,
			pb_gradienttex,
			pb_spline,
			pb_manualupdate,
			pb_texout,
			pb_overscan
			}	;

		// Parameter block
		IParamBlock2	*pblock;	//ref 0


		Texmap			*subtex[NSUBTEX]; //array of sub-materials
		static ParamDlg *uvGenDlg;
		UVGen			*uvGen;
		Interval		ivalid;

		//From MtlBase
		ParamDlg* CreateParamDlg(HWND hwMtlEdit, IMtlParams *imp);
		BOOL SetDlgThing(ParamDlg* dlg);
		void Update(TimeValue t, Interval& valid);
		void Reset();
		Interval Validity(TimeValue t);
		ULONG LocalRequirements(int subMtlNum);

		//TODO: Return the number of sub-textures
		int NumSubTexmaps() { return NSUBTEX; }
		//TODO: Return the pointer to the 'i-th' sub-texmap
		Texmap* GetSubTexmap(int i) { return subtex[i]; }
		void SetSubTexmap(int i, Texmap *m);
		TSTR GetSubTexmapSlotName(int i);
		
		//From Texmap
		RGBA EvalColor(ShadeContext& sc);
		float EvalMono(ShadeContext& sc);
		Point3 EvalNormalPerturb(ShadeContext& sc);

		//TODO: Returns TRUE if this texture can be used in the interactive renderer
		BOOL SupportTexDisplay() { return TRUE; }
		void ActivateTexDisplay(BOOL onoff);
		void DiscardTexHandle() ;
		BITMAPINFO* GetVPDisplayDIB(TimeValue t, TexHandleMaker& thmaker, Interval &valid, BOOL mono=FALSE, BOOL forceW=0, BOOL forceH=0);
		DWORD GetActiveTexHandle(TimeValue t, TexHandleMaker& thmaker);
		//TODO: Return UV transformation matrix for use in the viewports
		void GetUVTransform(Matrix3 &uvtrans) { uvGen->GetUVTransform(uvtrans); }
		//TODO: Return the tiling state of the texture for use in the viewports
		int GetTextureTiling() { return  uvGen->GetTextureTiling(); }
		int GetUVWSource() { return uvGen->GetUVWSource();}
		UVGen *GetTheUVGen() { return uvGen; }
		
		//TODO: Return anim index to reference index
		int SubNumToRefNum(int subNum) { return subNum; }
		
		
		// Loading/Saving
		IOResult Load(ILoad *iload);
		IOResult Save(ISave *isave);

		//From Animatable
		Class_ID ClassID() {return PAINTERTEXTURESAMPLE_CLASS_ID;}		
		SClass_ID SuperClassID() { return TEXMAP_CLASS_ID; }
		void GetClassName(TSTR& s) {s = GetString(IDS_CLASS_NAME);}

		RefTargetHandle Clone( RemapDir &remap );
		RefResult NotifyRefChanged(Interval changeInt, RefTargetHandle hTarget, 
			PartID& partID,  RefMessage message);


		int NumSubs() { return 2+NSUBTEX; }
		Animatable* SubAnim(int i); 
		TSTR SubAnimName(int i);

		// TODO: Maintain the number or references here 
		int NumRefs() { return 2+NSUBTEX; }
		RefTargetHandle GetReference(int i);
		void SetReference(int i, RefTargetHandle rtarg);



		int	NumParamBlocks() { return 1; }					// return number of ParamBlocks in this instance
		IParamBlock2* GetParamBlock(int i) { return pblock; } // return i'th ParamBlock
		IParamBlock2* GetParamBlockByID(BlockID id) { return (pblock->ID() == id) ? pblock : NULL; } // return id'd ParamBlock


		void* GetInterface(ULONG id);

		void DeleteThis() { delete this; }		
		//Constructor/Destructor

		PainterTextureSample();
		~PainterTextureSample();
		

// These are the IPainterCanvasInterface_V5 you must instatiate
		// This is called when the user tart a pen stroke
		BOOL  StartStroke();

		//This is called as the user strokes across the mesh or screen with the mouse down
		BOOL  PaintStroke(
						  BOOL hit,
						  IPoint2 mousePos, 
						  Point3 worldPoint, Point3 worldNormal,
						  Point3 localPoint, Point3 localNormal,
						  Point3 bary,  int index,
						  BOOL shift, BOOL ctrl, BOOL alt, 
						  float radius, float str,
						  float pressure, INode *node,
						  BOOL mirrorOn,
						  Point3 worldMirrorPoint, Point3 worldMirrorNormal,
						  Point3 localMirrorPoint, Point3 localMirrorNormal
						  ) ;

		// This is called as the user ends a strokes when the users has it set to always update
		BOOL  EndStroke();

		// This is called as the user ends a strokes when the users has it set to update on mouse up only
		// the canvas gets a list of all points, normals etc instead of one at a time
		//		int ct - the number of elements in the following arrays
		//  <...> see paintstroke() these are identical except they are arrays of values
		BOOL  EndStroke(int ct, BOOL *hit, IPoint2 *mousePos, 
						  Point3 *worldPoint, Point3 *worldNormal,
						  Point3 *localPoint, Point3 *localNormal,
						  Point3 *bary,  int *index,
						  BOOL *shift, BOOL *ctrl, BOOL *alt, 
						  float *radius, float *str,
						  float *pressure, INode **node,
						  BOOL mirrorOn,
						  Point3 *worldMirrorPoint, Point3 *worldMirrorNormal,
						  Point3 *localMirrorPoint, Point3 *localMirrorNormal);

		// This is called as the user cancels a stroke by right clicking
		BOOL  CancelStroke();	

		//This is called when the painter want to end a paint session for some reason.
		BOOL  SystemEndPaintSession();

		void PainterDisplay(TimeValue t, ViewExp *vpt, int flags) ;


//		void  Paint();
//		void  PaintOptions();

//		void  InitUI(HWND hWnd);
//		void  DestroyUI(HWND hWnd);
		

		void	ShowMap();
		void	UpdateMap();
		void	SaveMap();

		void	Fill();

		Point3 *InitMesh(Mesh *msh, Matrix3 tm, int &ct);
		Tab<Point3> loresWorldSpaceList;


		Point3 GetStrokeColor();
		int GetStrokeType();
		int GetSampleRate();
		int GetGradient();
		Texmap *GetGradientTex();
		INode *GetNode();

		PainterDlgProc *painterProc;
		InkStroker inker;

		IPainterInterface_V5 *pPainter;
		Interval texHandleValid;
		


		
//		ICustButton		*iPaintButton;

		Tab<Point3>		uvwPoints;
		Tab<TVFace>		uvwFaces;

		TexHandle *texHandle;
		

		Bitmap *bm;
		Bitmap *holdbm;
		BitmapInfo lowresBi;

		
		int width;
		Bitmap *BuildBitmap(int size) ;

		Point3 strokeColor;


		Tab<int> loresUVWIndexList;
		INode *node;



		void BuildWorldSpaceData(Mesh *msh, Matrix3 tm,
								int width, int height,
								Tab<Point3> &worldSpaceList,
								Tab<int> &uvwList,
								int whichText);
		HWND painterHwnd;
		int strokeType;

		PBBitmap *hiresBitmapPB;
//		Bitmap *hirereTheBM;

		CustomPointGatherer hiresGatherer;
		Tab<int>		hiresUVWIndexList;
		Tab<Point3>		hiresWorldSpaceList;
		int				hiresWidth,hiresHeight;

		Tab<float>      hiresStrList;
		Tab<float>      hiresRadiusList;
		Tab<Point3>		hiresPointList;
		Tab<Point3>		hiresMirrorPointList;
		BOOL			hiresMirror;

		void ClearData(BOOL lores = TRUE);
		void PaintHiresStroke(int ct, float *radius, float *str, Point3 *worldPos, Point3 *mirrorPos);

		void	CreateBitmap(int size);
		
		AColor Sample(ShadeContext& sc, float u,float v); 

		void HoldMap();

		void CleanUpEdges(INode *node, Bitmap *map, int channel, float blurRange);

	private:

};



class FaceData
{
	public:
		int count;

};

#define TVCOLOR_CHUNK 0x1000

class VertexPaintData : public LocalModData 
{
	
	public:

		VertexPaintData()
			{
			node = NULL;
			}

		LocalModData *Clone()
			{
			VertexPaintData *tmp = new VertexPaintData();
			tmp->faceList = faceList;
			tmp->vcColor = vcColor;
			tmp->vcColorHold = vcColorHold;
			tmp->vertexPosList = vertexPosList;
			return tmp;
			}

		Tab<Point3>	vertexPosList;

		//need a function to get mesh data
		void InitializeDataFromMesh(Mesh *msh, BOOL replace, int channel);
		//need a function to get poly data


		void CopyDataToMesh(Mesh *msh, int channel);

		INode *node;

		//need a face list
		Tab<FaceData> faceList;


		Tab<Point3> vcColor;
		Tab<Point3> vcColorHold;
		

};






class VCPainter : public Modifier, public IPainterCanvasInterface_V5 {
	public:

		BMM_Color_64 bit;
	enum { vcpainter_params };


//TODO: Add enums for various parameters
//TODO: Add enums for various parameters
		enum { 
			pb_bitmap,  pb_color,
			pb_stroketype,
			pb_samplerate,
			pb_gradient,
			pb_gradienttex,
			pb_spline
			}	;

		// Parameter block
		IParamBlock2	*pblock;	//ref 0


		static IObjParam *ip;			//Access to the interface
		
		// From Animatable
		TCHAR *GetObjectName() { return GetString(IDS_CLASS_NAME); }

		//From Modifier
		ChannelMask ChannelsUsed()  { return GEOM_CHANNEL|TOPO_CHANNEL|VERTCOLOR_CHANNEL|PART_DISPLAY|TEXMAP_CHANNEL; }
		//TODO: Add the channels that the modifier actually modifies
		ChannelMask ChannelsChanged() { return GEOM_CHANNEL|VERTCOLOR_CHANNEL|PART_DISPLAY|TEXMAP_CHANNEL; }
		//TODO: Return the ClassID of the object that the modifier can modify
		Class_ID InputType() {return defObjectClassID;}

		void ModifyObject(TimeValue t, ModContext &mc, ObjectState *os, INode *node);
		void NotifyInputChanged(Interval changeInt, PartID partID, RefMessage message, ModContext *mc);

		void NotifyPreCollapse(INode *node, IDerivedObject *derObj, int index);
		void NotifyPostCollapse(INode *node,Object *obj, IDerivedObject *derObj, int index);


		Interval LocalValidity(TimeValue t);

		// From BaseObject
		//TODO: Return true if the modifier changes topology
		BOOL ChangeTopology() {return FALSE;}		
		
		CreateMouseCallBack* GetCreateMouseCallBack() {return NULL;}

		BOOL HasUVW();
		void SetGenUVW(BOOL sw);


		void BeginEditParams(IObjParam *ip, ULONG flags,Animatable *prev);
		void EndEditParams(IObjParam *ip, ULONG flags,Animatable *next);


		Interval GetValidity(TimeValue t);

		// Automatic texture support
		
		// Loading/Saving
		IOResult Load(ILoad *iload);
		IOResult Save(ISave *isave);


		IOResult SaveLocalData(ISave *isave, LocalModData *pld);
		IOResult LoadLocalData(ILoad *iload, LocalModData **pld);


		//From Animatable
		Class_ID ClassID() {return VCPAINTER_CLASS_ID;}		
		SClass_ID SuperClassID() { return OSM_CLASS_ID; }
		void GetClassName(TSTR& s) {s = GetString(IDS_CLASS_NAME);}

		RefTargetHandle Clone( RemapDir &remap );
		RefResult NotifyRefChanged(Interval changeInt, RefTargetHandle hTarget, 
			PartID& partID,  RefMessage message);


		int NumSubs() { return 1; }
		TSTR SubAnimName(int i) { return GetString(IDS_PARAMS); }				
		Animatable* SubAnim(int i) { return pblock; }

		// TODO: Maintain the number or references here
		int NumRefs() { return 1; }
		RefTargetHandle GetReference(int i) { return pblock; }
		void SetReference(int i, RefTargetHandle rtarg) { pblock=(IParamBlock2*)rtarg; }




		int	NumParamBlocks() { return 1; }					// return number of ParamBlocks in this instance
		IParamBlock2* GetParamBlock(int i) { return pblock; } // return i'th ParamBlock
		IParamBlock2* GetParamBlockByID(BlockID id) { return (pblock->ID() == id) ? pblock : NULL; } // return id'd ParamBlock

		void DeleteThis() { delete this; }		

		void* GetInterface(ULONG id);

		//Constructor/Destructor

		VCPainter();
		~VCPainter();	
		
//		void ApplyStroke(Point3 *vcColor, float *weights, float *str, int count);

// These are the IPainterCanvasInterface_V5 you must instatiate
		// This is called when the user tart a pen stroke
		BOOL  StartStroke();

		//This is called as the user strokes across the mesh or screen with the mouse down
		BOOL  PaintStroke(
						  BOOL hit,
						  IPoint2 mousePos, 
						  Point3 worldPoint, Point3 worldNormal,
						  Point3 localPoint, Point3 localNormal,
						  Point3 bary,  int index,
						  BOOL shift, BOOL ctrl, BOOL alt, 
						  float radius, float str,
						  float pressure, INode *node,
						  BOOL mirrorOn,
						  Point3 worldMirrorPoint, Point3 worldMirrorNormal,
						  Point3 localMirrorPoint, Point3 localMirrorNormal
						  ) ;

		// This is called as the user ends a strokes when the users has it set to always update
		BOOL  EndStroke();

		// This is called as the user ends a strokes when the users has it set to update on mouse up only
		// the canvas gets a list of all points, normals etc instead of one at a time
		//		int ct - the number of elements in the following arrays
		//  <...> see paintstroke() these are identical except they are arrays of values
		BOOL  EndStroke(int ct, BOOL *hit, IPoint2 *mousePos, 
						  Point3 *worldPoint, Point3 *worldNormal,
						  Point3 *localPoint, Point3 *localNormal,
						  Point3 *bary,  int *index,
						  BOOL *shift, BOOL *ctrl, BOOL *alt, 
						  float *radius, float *str,
						  float *pressure, INode **node,
						  BOOL mirrorOn,
						  Point3 *worldMirrorPoint, Point3 *worldMirrorNormal,
						  Point3 *localMirrorPoint, Point3 *localMirrorNormal);

		// This is called as the user cancels a stroke by right clicking
		BOOL  CancelStroke();

		//This is called when the painter want to end a paint session for some reason.
		BOOL  SystemEndPaintSession();

		void PainterDisplay(TimeValue t, ViewExp *vpt, int flags) ;

//		void  Paint();
//		void  PaintOptions();

//		void  InitUI(HWND hWnd);
//		void  DestroyUI(HWND hWnd);
		


		void	Fill();

		void ClearData();


//		ICustButton		*iPaintButton;
		IPainterInterface_V5 *pPainter;

		INode* GetNodeFromModContext(VertexPaintData *vmd);
		LocalModData* GetLocalDataFromNode(INode *node);

		Tab<VertexPaintData*> vmdList;

		PainterDlgProc *painterProc;
		InkStroker inker;

		Point3 GetStrokeColor();
		int GetStrokeType();
		int GetSampleRate();
		int GetGradient();
		Texmap *GetGradientTex();
		INode *GetNode();

		Point3 strokeColor;

		void HoldMap();


	private:

		HWND hwnd;
//		int lagRate, lagCount;
		int strokeType;
		BOOL firstLineStroke;

};



class PainterTextureSampleClassDesc:public ClassDesc2 {
	public:
	int 			IsPublic() { return TRUE; }
	void *			Create(BOOL loading = FALSE) { return new PainterTextureSample(); }
	const TCHAR *	ClassName() { return GetString(IDS_CLASS_NAME); }
	SClass_ID		SuperClassID() { return TEXMAP_CLASS_ID; }
	Class_ID		ClassID() { return PAINTERTEXTURESAMPLE_CLASS_ID; }
	const TCHAR* 	Category() { return GetString(IDS_CATEGORY); }

	const TCHAR*	InternalName() { return _T("PainterTextureSample"); }	// returns fixed parsable name (scripter-visible name)
	HINSTANCE		HInstance() { return hInstance; }				// returns owning module handle

};


class VCPainterClassDesc:public ClassDesc2 {
	public:
	int 			IsPublic() { return TRUE; }
	void *			Create(BOOL loading = FALSE) { return new VCPainter(); }
	const TCHAR *	ClassName() { return GetString(IDS_CLASS_VCNAME); }
	SClass_ID		SuperClassID() { return OSM_CLASS_ID; }
	Class_ID		ClassID() { return VCPAINTER_CLASS_ID; }
	const TCHAR* 	Category() { return GetString(IDS_CATEGORY); }

	const TCHAR*	InternalName() { return _T("VCPainter"); }	// returns fixed parsable name (scripter-visible name)
	HINSTANCE		HInstance() { return hInstance; }				// returns owning module handle

};


class HoldMapRestore : public RestoreObj {
	public:
		PainterTextureSample *tex;

//		Bitmap *ulowResMap, *uhiResMap;
//		Bitmap *rlowResMap, *rhiResMap;

		PBITMAPINFO ulowResDIB,uhiResDIB;
		BOOL redo;
		PBITMAPINFO rlowResDIB,rhiResDIB;

		HoldMapRestore(PainterTextureSample *c) ;

		~HoldMapRestore();
		void Restore(int isUndo);
		void Redo();
		void EndHold() 
			{ 
			tex->ClearAFlag(A_HELD);
			}
		TSTR Description() { return TSTR(_T(GetString(IDS_PW_PAINT))); }
	};


class HoldVCRestore : public RestoreObj {
	public:
		VCPainter *mod;
		VertexPaintData *modData;

		Tab<Point3> uVC;
		Tab<Point3> rVC;


		HoldVCRestore(VCPainter *c,VertexPaintData *vmd) ;

		void Restore(int isUndo);
		void Redo();
		void EndHold() 
			{ 
			mod->ClearAFlag(A_HELD);
			}
		TSTR Description() { return TSTR(_T(GetString(IDS_PW_PAINT))); }
	};


#endif // __PAINTERTEXTURESAMPLE__H
