#include "PainterTextureSample.h"


void PainterTextureSample::ClearData(BOOL lores)
{
	//copy our current bitmap into our hold
	int iret = bm->CopyImage(holdbm,COPY_IMAGE_CROP,0);
}

void	PainterTextureSample::Fill()
{
	pblock->GetValue( pb_bitmap, 0,hiresBitmapPB, FOREVER );

	Point3 color;
	pblock->GetValue( pb_color, 0,color, FOREVER );

	if ( (hiresBitmapPB) &&  (hiresBitmapPB->bm ) )
		{
		if (hiresUVWIndexList.Count() > 0)
			inker.Fill(hiresBitmapPB->bm,color,	hiresUVWIndexList.Addr(0), hiresUVWIndexList.Count());
		}


	if (bm)
		{
		if (loresUVWIndexList.Count() > 0)
			inker.Fill(bm,color,	loresUVWIndexList.Addr(0), loresUVWIndexList.Count());
		}


}



void PainterTextureSample::PaintHiresStroke(int ct, float *radius, float *str, Point3 *worldPos, Point3 *mirrorPos)

{
	if (ct == 0) return;


	if ((width == hiresWidth) && (width == hiresHeight))
		{
		pblock->GetValue( pb_bitmap, 0,hiresBitmapPB, FOREVER );
		if ( (hiresBitmapPB) &&  (hiresBitmapPB->bm )  )
			{
			hiresBitmapPB->bm->CopyImage(bm,COPY_IMAGE_CROP,0);
			}
		}
	else
		{
		hiresGatherer.ClearWeights();
		ICurve *curve = pPainter->GetFalloffGraph();
		Tab<float> dist;
		dist.SetCount(ct);
		float totalDist = 0.0f;
		dist[0] = 0.0f;
		for (int i =1; i < dist.Count(); i++)
			{
			totalDist += Length(worldPos[i] - worldPos[i-1]);
			dist[i] = totalDist;
			}

		for (i = 1; i < ct;  i++)
			{
			hiresGatherer.AddWeightFromSegment(worldPos[i-1],radius[i-1],str[i-1],
											worldPos[i],radius[i],str[i],curve,FALSE,FALSE,
											dist[i-1]);
			if (mirrorPos)
				hiresGatherer.AddWeightFromSegment(worldPos[i-1],radius[i-1],str[i-1],
											mirrorPos[i],radius[i],str[i],curve,FALSE,TRUE,
											dist[i-1]);
			}
		int count = 0;
		float *gstr = hiresGatherer.GetStr(0, count);
		float *gweight = hiresGatherer.GetWeights(0, count);
		float *u = hiresGatherer.GetU(0, count);

		float strokeLen = 0;
		int scount = pPainter->GetStrokeCount();
		Point3 *wp = pPainter->GetStrokePointWorld();

		for (i = 1; i < scount; i++)
			{
			strokeLen += Length(wp[i] - wp[i-1]);
			}
	

		pblock->GetValue( pb_bitmap, 0,hiresBitmapPB, FOREVER );
		if ( (hiresBitmapPB) &&  (hiresBitmapPB->bm ) )
			{
//		if (strokeType == 0)
				{
				inker.ApplyStroke(hiresBitmapPB->bm, gweight, gstr,  hiresUVWIndexList.Addr(0),count,GetStrokeColor(),
							GetGradient(),u,GetGradientTex(),strokeLen);
				}
			}
		}
	BOOL manualUpdate;
	pblock->GetValue( pb_manualupdate, 0,manualUpdate, FOREVER );
	if (!manualUpdate)
		{
		UpdateMap();
		}
		

}

// This is called when the user tart a pen stroke
BOOL  PainterTextureSample::StartStroke()
	{

	HoldMap();

	pblock->GetValue( pb_color, 0, strokeColor, FOREVER);
	pblock->GetValue(pb_stroketype,0,strokeType,FOREVER);

	painterProc->StartStroke();


	//copy our current bitmap into our hold
	int iret = holdbm->CopyImage(bm,COPY_IMAGE_CROP,0);


	hiresStrList.ZeroCount();
	hiresRadiusList.ZeroCount();
	hiresPointList.ZeroCount();
	hiresMirrorPointList.ZeroCount();
	
	int nodeCount =  GetCOREInterface()->GetSelNodeCount();
	if (nodeCount > 0)
		node = GetCOREInterface()->GetSelNode(0);

	return TRUE;
	}

//This is called as the user strokes across the mesh or screen with the mouse down
BOOL  PainterTextureSample::PaintStroke(		  BOOL hit,
						  IPoint2 mousePos, 
						  Point3 worldPoint, Point3 worldNormal,
						  Point3 localPoint, Point3 localNormal,
						  Point3 bary,  int index,
						  BOOL shift, BOOL ctrl, BOOL alt, 
						  float radius, float str,
						  float pressure, INode *node,
						  BOOL mirrorOn,
						  Point3 worldMirrorPoint, Point3 worldMirrorNormal,
						  Point3 localMirrorPoint, Point3 localMirrorNormal
						  ) 
{
	static IPoint2 lastPoint;
	

	hiresStrList.Append(1,&str,100); 
	float tempRadius = radius * 0.5f;
	hiresRadiusList.Append(1,&tempRadius,100);
	hiresPointList.Append(1,&worldPoint,100);
	if (mirrorOn)
		hiresMirrorPointList.Append(1,&worldMirrorPoint,100);
	hiresMirror = mirrorOn;

	if (hit)
		{
		ClearData();

   		painterProc->PaintStroke(hit,mousePos,worldPoint, worldNormal,localPoint, localNormal,
								bary, index,
								shift, ctrl,  alt, 
								radius,  str, pressure, node,
								mirrorOn,	
							    worldMirrorPoint, worldMirrorNormal,localMirrorPoint, localMirrorNormal) ;
		}
	else
		{

		}
	lastPoint = mousePos;


return TRUE;
}

// This is called as the user ends a strokes when the users has it set to always update
BOOL  PainterTextureSample::EndStroke()
	{
//	ClearData();


//apply stroke to hires bitmap


//retrieve stroke data

	int ct = pPainter->GetStrokeCount();
	float *str = pPainter->GetStrokeStr();
	float *radius = pPainter->GetStrokeRadius();
	Point3 *point = pPainter->GetStrokePointWorld();
	Point3 *mirrorPoint = pPainter->GetStrokePointWorldMirror();

	if (hiresMirror)
		PaintHiresStroke(ct, radius, str, point, mirrorPoint);
	else PaintHiresStroke(ct, radius, str, point, NULL);

	holdbm->CopyImage(bm,COPY_IMAGE_CROP,0);

	texHandleValid.Empty();
	DiscardTexHandle();

	theHold.Accept(GetString(IDS_PW_PAINT));



	return TRUE;
	}

// This is called as the user ends a strokes when the users has it set to update on mouse up only
// the canvas gets a list of all points, normals etc instead of one at a time
//		int ct - the number of elements in the following arrays
//  <...> see paintstroke() these are identical except they are arrays of values
BOOL  PainterTextureSample::EndStroke(int ct, BOOL *hit, IPoint2 *mousePos, 
						  Point3 *worldPoint, Point3 *worldNormal,
						  Point3 *localPoint, Point3 *localNormal,
						  Point3 *bary,  int *index,
						  BOOL *shift, BOOL *ctrl, BOOL *alt, 
						  float *radius, float *str,
						  float *pressure, INode **node,
						  BOOL mirrorOn,
						  Point3 *worldMirrorPoint, Point3 *worldMirrorNormal,
						  Point3 *localMirrorPoint, Point3 *localMirrorNormal)
	{
	ClearData();
	painterProc->EndStroke(ct, hit, mousePos, 
						  worldPoint, worldNormal,
						  localPoint, localNormal,
						  bary,  index,
						  shift, ctrl, alt, 
						  radius, str,
						  pressure, node,
						  mirrorOn,
						  worldMirrorPoint, worldMirrorNormal,
						  localMirrorPoint, localMirrorNormal);


	int count = pPainter->GetStrokeCount();
	float *strList = pPainter->GetStrokeStr();
	float *radiusList = pPainter->GetStrokeRadius();
	Point3 *pointList = pPainter->GetStrokePointWorld();
	Point3 *mirrorPointList = pPainter->GetStrokePointWorldMirror();

	if (hiresMirror)
		PaintHiresStroke(count, radiusList, strList, pointList, mirrorPointList);
	else PaintHiresStroke(count, radiusList, strList, pointList, NULL);


	texHandleValid.Empty();
	DiscardTexHandle();

	theHold.Accept(GetString(IDS_PW_PAINT));

	return TRUE;
	}

// This is called as the user cancels a stroke by right clicking
BOOL  PainterTextureSample::CancelStroke()
	{
	theHold.Cancel();

	int iret = bm->CopyImage(holdbm,COPY_IMAGE_CROP,0);
	texHandleValid.Empty();
	DiscardTexHandle();

	return TRUE;
	}


void PainterTextureSample::PainterDisplay(TimeValue t, ViewExp *vpt, int flags)
	{
	painterProc->PainterDisplay(t, vpt, flags);
	}









void VCPainter::ClearData()
{
	//copy our current bitmap into our hold
	for (int i =0; i < vmdList.Count(); i++)
		{
//		float *addr = vmdList[i]->strList.Addr(0);
//		memset(addr,0,vmdList[i]->vertexPosList.Count()*sizeof(float));
		}
}

void	VCPainter::Fill()
{

	Point3 color;


	pblock->GetValue( pb_color, 0, color, FOREVER);

	for (int j = 0; j < vmdList.Count(); j++)
		{
		inker.Fill(vmdList[j]->vcColor.Addr(0), vmdList[j]->vcColor.Count(), color);

		}


}


// This is called when the user tart a pen stroke
BOOL  VCPainter::StartStroke()
	{

	HoldMap();

	pblock->GetValue( pb_color, 0, strokeColor, FOREVER);
	painterProc->StartStroke();

	ClearData();

	for (int i = 0; i < vmdList.Count(); i++)
		{
		vmdList[i]->vcColorHold = vmdList[i]->vcColor;
		}

	pblock->GetValue(pb_stroketype,0,strokeType,FOREVER);

	return TRUE;
	}

//This is called as the user strokes across the mesh or screen with the mouse down
BOOL  VCPainter::PaintStroke(		  BOOL hit,
						  IPoint2 mousePos, 
						  Point3 worldPoint, Point3 worldNormal,
						  Point3 localPoint, Point3 localNormal,
						  Point3 bary,  int index,
						  BOOL shift, BOOL ctrl, BOOL alt, 
						  float radius, float str,
						  float pressure, INode *node,
						  BOOL mirrorOn,
						  Point3 worldMirrorPoint, Point3 worldMirrorNormal,
						  Point3 localMirrorPoint, Point3 localMirrorNormal
						  ) 
{
	static IPoint2 lastPoint;
	

	float tempRadius = radius * 0.5f;



		

	for (int i = 0; i < vmdList.Count(); i++)
		{
		vmdList[i]->vcColor = vmdList[i]->vcColorHold;

		}

	painterProc->PaintStroke(hit,mousePos,worldPoint, worldNormal,localPoint, localNormal,
								bary, index,
								shift, ctrl,  alt, 
								radius,  str, pressure, node,
								mirrorOn,	
								worldMirrorPoint, worldMirrorNormal,localMirrorPoint, localMirrorNormal) ;
		lastPoint = mousePos;


return TRUE;
}

// This is called as the user ends a strokes when the users has it set to always update
BOOL  VCPainter::EndStroke()
	{
//	ClearData();

//apply stroke to hires bitmap
	NotifyDependents(FOREVER,PART_ALL,REFMSG_CHANGE);//FIX set to just vc color channel
	theHold.Accept(GetString(IDS_PW_PAINT));

	return TRUE;
	}

// This is called as the user ends a strokes when the users has it set to update on mouse up only
// the canvas gets a list of all points, normals etc instead of one at a time
//		int ct - the number of elements in the following arrays
//  <...> see paintstroke() these are identical except they are arrays of values
BOOL  VCPainter::EndStroke(int ct, BOOL *hit, IPoint2 *mousePos, 
						  Point3 *worldPoint, Point3 *worldNormal,
						  Point3 *localPoint, Point3 *localNormal,
						  Point3 *bary,  int *index,
						  BOOL *shift, BOOL *ctrl, BOOL *alt, 
						  float *radius, float *str,
						  float *pressure, INode **node,
						  BOOL mirrorOn,
						  Point3 *worldMirrorPoint, Point3 *worldMirrorNormal,
						  Point3 *localMirrorPoint, Point3 *localMirrorNormal)
	{
	ClearData();
	painterProc->EndStroke(ct, hit, mousePos, 
						  worldPoint, worldNormal,
						  localPoint, localNormal,
						  bary,  index,
						  shift, ctrl, alt, 
						  radius, str,
						  pressure, node,
						  mirrorOn,
						  worldMirrorPoint, worldMirrorNormal,
						  localMirrorPoint, localMirrorNormal);
	theHold.Accept(GetString(IDS_PW_PAINT));

	NotifyDependents(FOREVER,PART_ALL,REFMSG_CHANGE);//FIX set to just vc color channel


	return TRUE;
	}
	
BOOL  VCPainter::CancelStroke()

{
	theHold.Cancel();

	for (int i = 0; i < vmdList.Count(); i++)
		{
		vmdList[i]->vcColor = vmdList[i]->vcColorHold ;
		}
	return TRUE;
}
void VCPainter::PainterDisplay(TimeValue t, ViewExp *vpt, int flags)
	{
	painterProc->PainterDisplay(t, vpt, flags);
	}
