/**********************************************************************
 *<
	FILE: VCPainter.cpp

	DESCRIPTION:	Appwizard generated plugin

	CREATED BY: 

	HISTORY: 

 *>	Copyright (c) 2000, All Rights Reserved.
 **********************************************************************/

#include "PainterTextureSample.h"

#include "modstack.h"


static VCPainterClassDesc VCPainterDesc;
ClassDesc2* GetVCPainterDesc() { return &VCPainterDesc; }





static ParamBlockDesc2 vcpainter_param_blk ( VCPainter::vcpainter_params, _T("params"),  0, &VCPainterDesc, 
	P_AUTO_CONSTRUCT + P_AUTO_UI, PBLOCK_REF, 
	//rollout
	IDD_VCPANEL, IDS_PARAMS, 0, 0, NULL,
	// params

	VCPainter::pb_color,	 _T("color"),	TYPE_RGBA,				0,	IDS_PW_COLOR,	
		p_default,		Color(0,0,0), 
		p_ui,			TYPE_COLORSWATCH, IDC_COLOR, 
		end,


//	VCPainter::pb_stroketype,  _T("stroketype"), TYPE_INT, 	P_RESET_DEFAULT, 	IDS_PW_STROKETYPE, 
//		p_default, 		0,	
//		p_range, 		0, 2, 
//		p_ui, 			TYPE_RADIO, 3,IDC_RADIO1,IDC_RADIO2,IDC_RADIO3,
//		end, 
	VCPainter::pb_stroketype,	_T("strokeType"),	TYPE_INT,	0,	IDS_PW_STROKETYPE,
	// optional tagged param specs
		p_default,		kPen,
		p_ui,			TYPE_INTLISTBOX, IDC_INKS_COMBO, 4,
						IDS_PW_PEN, IDS_PW_LINE, IDS_PW_RECTANGLE,IDS_PW_CIRCLE,
		p_vals,			kPen, kLine, kRectangle,kCircle,
		end,

	VCPainter::pb_samplerate,	_T("sampleRate"),	TYPE_INT,	P_RESET_DEFAULT,	IDS_PW_SAMPLERATE,
		p_default,		5,
		p_range, 		0, 100, 
		p_ui,			TYPE_SPINNER, EDITTYPE_INT, IDC_SAMPLERATE, IDC_SAMPLERATESPINNER, 0.5f,
		end,

	VCPainter::pb_gradient,	_T("gradient"),	TYPE_INT,	0,	IDS_PW_GRADIENT,
	// optional tagged param specs
		p_default,		kNoGradient,
		p_ui,			TYPE_INTLISTBOX, IDC_GRADIENT_COMBO, 4,
						IDS_PW_NOGRADIENT, IDS_PW_UGRADIENT, IDS_PW_VGRADIENT,IDS_PW_UVGRADIENT,
		p_vals,			kNoGradient, kUGradient, kVGradient,kUVGradient,
		end,

	VCPainter::pb_gradienttex, 	_T("gradientTexture"),		TYPE_TEXMAP, 		0,				IDS_PW_TEXMAP,
		p_ui, 			TYPE_TEXMAPBUTTON, 	IDC_GRADIENT, 
		end, 


	VCPainter::pb_spline, 	_T("node"),		TYPE_INODE, 		0,				IDS_PW_NODE,
		p_ui, 			TYPE_PICKNODEBUTTON, 	IDC_SPLINE, 
		end, 


	end
	);




IObjParam *VCPainter::ip			= NULL;


void VertexPaintData::InitializeDataFromMesh(Mesh *msh, BOOL replace, int channel)
{
//get the face data

	int numFaces = msh->numFaces;
	int numVertices = numFaces * 3;

	faceList.SetCount(numFaces);
	vertexPosList.SetCount(numVertices);
	vcColor.SetCount(numVertices);
	vcColorHold.SetCount(numVertices);
//	strList.SetCount(numVertices);

	Matrix3 tm(1);

	if (node)
		tm = node->GetObjectTM(GetCOREInterface()->GetTime());

	Tab<int> vct;
	vct.SetCount(numVertices);


	for (int i = 0; i < numVertices; i++)
		{
		vct[i] = 0;
		if (!replace)
			{
			vcColor[i] = Point3(0.0f,0.0f,0.0f);
			vcColorHold[i] = Point3(0.0f,0.0f,0.0f);
			}
//		vertexPosList[i] = msh->verts[i]*tm;
//		strList[i] = 0.0f;

		}
	int ct = 0;
	Point3 *verts = msh->verts;

//FIX
	UVVert *tvVerts = msh->mapVerts(channel);
	TVFace *tvFaces = msh->mapFaces(channel);


	for (i = 0; i < numFaces; i++)
		{
		faceList[i].count = 3;
		for (int j = 0; j < 3; j++)
			{
			int index = msh->faces[i].v[j];
			vertexPosList[ct++] = verts[index]*tm;
			if (!replace)
				{
				if (tvFaces)
					{
					int tindex = i*3 + j;
					int vindex = tvFaces[i].t[j];
					Point3 color = tvVerts[vindex];
					vcColor[tindex] += tvVerts[vindex];
					vcColorHold[tindex] += tvVerts[vindex];
					vct[tindex] += 1;
					}


				}

			}



		}

	for (i = 0; i < numVertices; i++)
		{
		
		if (!replace)
			{
			if (vct[i])
				{
				vcColor[i] = vcColor[i]/(float)vct[i];
				vcColorHold[i] = vcColorHold[i]/(float)vct[i];
				}
			}
		}

}


void VertexPaintData::CopyDataToMesh(Mesh *msh, int channel)
{

	if (faceList.Count() != msh->numFaces)
		InitializeDataFromMesh(msh,FALSE,channel);


	msh->setMapSupport(channel);


	msh->setNumMapVerts(channel,vcColor.Count());
	msh->setNumMapFaces(channel,faceList.Count());

	int numFaces = faceList.Count();
	int  numVertices = vcColor.Count();
	UVVert *tvVerts = msh->mapVerts(channel);
	TVFace *tvFaces = msh->mapFaces(channel);
	for (int i = 0; i < numVertices; i++)
		{
		tvVerts[i] = vcColor[i];
		}

	int ct = 0;
	for (i = 0; i < numFaces; i++)
		{
		tvFaces[i].t[0] = ct++;
		tvFaces[i].t[1] = ct++;
		tvFaces[i].t[2] = ct++;
		}

}





class sMyEnumProc : public DependentEnumProc 
	{
      public :
      virtual int proc(ReferenceMaker *rmaker); 
      INodeTab Nodes;              
	};

int sMyEnumProc::proc(ReferenceMaker *rmaker) 
	{ 
	if (rmaker->SuperClassID()==BASENODE_CLASS_ID)    
			{
            Nodes.Append(1, (INode **)&rmaker);                 
			}
     return 0;              
	}


//--- VCPainter -------------------------------------------------------
VCPainter::VCPainter()
{
	VCPainterDesc.MakeAutoParamBlocks(this);
//	iPaintButton = NULL;
	pPainter = NULL;
	painterProc = NULL;
}

VCPainter::~VCPainter()
{
//	if (iPaintButton)
//		ReleaseICustButton(iPaintButton);

//	iPaintButton = NULL;
	if (pPainter)
		{
		if (pPainter->InPaintMode() )
			pPainter->EndPaintSession();
		}
}

BOOL RecursePipeAndMatch(VertexPaintData *smd, Object *obj)
	{
	SClass_ID		sc;
	IDerivedObject* dobj;
	Object *currentObject = obj;

	if ((sc = obj->SuperClassID()) == GEN_DERIVOB_CLASS_ID)
		{
		dobj = (IDerivedObject*)obj;
		while (sc == GEN_DERIVOB_CLASS_ID)
			{
			for (int j = 0; j < dobj->NumModifiers(); j++)
				{
				ModContext *mc = dobj->GetModContext(j);
				if (mc->localData == smd)
					{
					return TRUE;
					}

				}
			dobj = (IDerivedObject*)dobj->GetObjRef();
			currentObject = (Object*) dobj;
			sc = dobj->SuperClassID();
			}
		}

	int bct = currentObject->NumPipeBranches(FALSE);
	if (bct > 0)
		{
		for (int bi = 0; bi < bct; bi++)
			{
			Object* bobj = currentObject->GetPipeBranch(bi,FALSE);
			if (RecursePipeAndMatch(smd, bobj)) return TRUE;
			}

		}

	return FALSE;
}


LocalModData* RecursePipeAndMatchModifier(Modifier *mod, Object *obj)
	{
	SClass_ID		sc;
	IDerivedObject* dobj;
	Object *currentObject = obj;

	if ((sc = obj->SuperClassID()) == GEN_DERIVOB_CLASS_ID)
		{
		dobj = (IDerivedObject*)obj;
		while (sc == GEN_DERIVOB_CLASS_ID)
			{
			for (int j = 0; j < dobj->NumModifiers(); j++)
				{
				ModContext *mc = dobj->GetModContext(j);
				if (dobj->GetModifier(j) == mod)
					return mc->localData;


				}
			dobj = (IDerivedObject*)dobj->GetObjRef();
			currentObject = (Object*) dobj;
			sc = dobj->SuperClassID();
			}
		}

	int bct = currentObject->NumPipeBranches(FALSE);
	if (bct > 0)
		{
		for (int bi = 0; bi < bct; bi++)
			{
			Object* bobj = currentObject->GetPipeBranch(bi,FALSE);
			return RecursePipeAndMatchModifier(mod, bobj);
			}

		}

	return NULL;
}


INode* VCPainter::GetNodeFromModContext(VertexPaintData *vmd)
	{

	int	i;

    sMyEnumProc dep;              
	EnumDependents(&dep);
	for ( i = 0; i < dep.Nodes.Count(); i++)
		{
		INode *node = dep.Nodes[i];
		BOOL found = FALSE;

		if (node)
			{
			Object* obj = node->GetObjectRef();
	
			if ( RecursePipeAndMatch(vmd,obj) )
				{
				return node;
				}
			}
		}
	return NULL;
	}

LocalModData* VCPainter::GetLocalDataFromNode(INode *node)
	{


	if (node)
		{
		Object* obj = node->GetObjectRef();
	
		return  RecursePipeAndMatchModifier(this,obj);
		}
	return NULL;

	}

/*===========================================================================*\
 |	The validity of the parameters.  First a test for editing is performed
 |  then Start at FOREVER, and intersect with the validity of each item
\*===========================================================================*/
Interval VCPainter::LocalValidity(TimeValue t)
{
	// if being edited, return NEVER forces a cache to be built 
	// after previous modifier.
	if (TestAFlag(A_MOD_BEING_EDITED))
		return NEVER;  
	//TODO: Return the validity interval of the modifier
	return NEVER;
}


/*************************************************************************************************
*
	Between NotifyPreCollapse and NotifyPostCollapse, Modify is
	called by the system.  NotifyPreCollapse can be used to save any plugin dependant data e.g.
	LocalModData
*
\*************************************************************************************************/

void VCPainter::NotifyPreCollapse(INode *node, IDerivedObject *derObj, int index)
{
	//TODO:  Perform any Pre Stack Collapse methods here
}



/*************************************************************************************************
*
	NotifyPostCollapse can be used to apply the modifier back onto to the stack, copying over the
	stored data from the temporary storage.  To reapply the modifier the following code can be 
	used

	Object *bo = node->GetObjectRef();
	IDerivedObject *derob = NULL;
	if(bo->SuperClassID() != GEN_DERIVOB_CLASS_ID)
	{
		derob = CreateDerivedObject(obj);
		node->SetObjectRef(derob);
	}
	else
		derob = (IDerivedObject*) bo;

	// Add ourselves to the top of the stack
	derob->AddModifier(this,NULL,derob->NumModifiers());

*
\*************************************************************************************************/

void VCPainter::NotifyPostCollapse(INode *node,Object *obj, IDerivedObject *derObj, int index)
{
	//TODO: Perform any Post Stack collapse methods here.

}


/*************************************************************************************************
*
	ModifyObject will do all the work in a full modifier
    This includes casting objects to their correct form, doing modifications
	changing their parameters, etc
*
\************************************************************************************************/


void VCPainter::ModifyObject(TimeValue t, ModContext &mc, ObjectState * os, INode *node) 
{
	//TODO: Add the code for actually modifying the object
	if (mc.localData == NULL)
		{
		VertexPaintData *vmd = new VertexPaintData();
		mc.localData = vmd;

		vmd->node = GetNodeFromModContext(vmd);

		if (os->obj->IsSubClassOf(triObjectClassID)) 
			{
			TriObject *tobj = (TriObject*)os->obj;
				// Apply our mapping
			Mesh &mesh = tobj->GetMesh();
			
			vmd->InitializeDataFromMesh(&mesh,FALSE,0);

			}

		}
	VertexPaintData *vmd = (VertexPaintData *) mc.localData;
	if (vmd->node == NULL)
		{
		vmd->node = GetNodeFromModContext(vmd);
		}

	BOOL found = FALSE;
	for (int i = 0; i < vmdList.Count(); i++)
		{
		if (vmdList[i] == vmd)
			found = TRUE;
		}

	if (!found)
		vmdList.Append(1,&vmd);

	if (os->obj->IsSubClassOf(triObjectClassID)) 
		{
		TriObject *tobj = (TriObject*)os->obj;
				// Apply our mapping
		Mesh &mesh = tobj->GetMesh();
			
		vmd->CopyDataToMesh(&mesh,0);
		}


	os->obj->UpdateValidity(TEXMAP_CHAN_NUM,GetValidity(t));	

}


void VCPainter::BeginEditParams( IObjParam *ip, ULONG flags,Animatable *prev )
{
	this->ip = ip;
	VCPainterDesc.BeginEditParams(ip, this, flags, prev);
	painterProc = new PainterDlgProc(this);
	vcpainter_param_blk.SetUserDlgProc( painterProc);


}

void VCPainter::EndEditParams( IObjParam *ip, ULONG flags,Animatable *next)
{
	VCPainterDesc.EndEditParams(ip, this, flags, next);
	this->ip = NULL;
	vmdList.ZeroCount();
}



Interval VCPainter::GetValidity(TimeValue t)
{
	Interval valid = FOREVER;
	//TODO: Return the validity interval of the modifier
	return valid;
}




RefTargetHandle VCPainter::Clone(RemapDir& remap)
{
	VCPainter* newmod = new VCPainter();	
	//TODO: Add the cloning code here
	newmod->ReplaceReference(PBLOCK_REF,pblock->Clone(remap));
	BaseClone(this, newmod, remap);
	return(newmod);
}


//From ReferenceMaker 
RefResult VCPainter::NotifyRefChanged(
		Interval changeInt, RefTargetHandle hTarget,
		PartID& partID,  RefMessage message) 
{
	//TODO: Add code to handle the various reference changed messages
	switch (message) 
		{
		case REFMSG_CHANGE:
			if (hTarget == pblock)
				{
				ParamID changing_param = pblock->LastNotifyParamID();

				vcpainter_param_blk.InvalidateUI(changing_param);
				return REF_STOP;
				}
			break;

				
		}
	return REF_SUCCEED;
}

/****************************************************************************************
*
 	NotifyInputChanged is called each time the input object is changed in some way
 	We can find out how it was changed by checking partID and message
*
\****************************************************************************************/

void VCPainter::NotifyInputChanged(Interval changeInt, PartID partID, RefMessage message, ModContext *mc)
{

}



//From Object
BOOL VCPainter::HasUVW() 
{ 
	//TODO: Return whether the object has UVW coordinates or not
	return TRUE; 
}

void VCPainter::SetGenUVW(BOOL sw) 
{  
	if (sw==HasUVW()) return;
	//TODO: Set the plugin internal value to sw				
}

IOResult VCPainter::Load(ILoad *iload)
{
	//TODO: Add code to allow plugin to load its data
	
	return IO_OK;
}

IOResult VCPainter::Save(ISave *isave)
{
	//TODO: Add code to allow plugin to save its data
	
	return IO_OK;
}


IOResult VCPainter::SaveLocalData(ISave *isave, LocalModData *pld)
{

	ULONG		nb;

	VertexPaintData *vmd = (VertexPaintData*)pld;

	
	isave->BeginChunk(TVCOLOR_CHUNK);
	int c = vmd->vertexPosList.Count();
	isave->Write(&c,sizeof(c),&nb);
	isave->Write(vmd->vertexPosList.Addr(0),sizeof(Point3)*c,&nb);

	c = vmd->faceList.Count();
	isave->Write(&c,sizeof(c),&nb);
	isave->Write(vmd->faceList.Addr(0),sizeof(FaceData)*c,&nb);

	c = vmd->vcColor.Count();
	isave->Write(&c,sizeof(c),&nb);
	isave->Write(vmd->vcColor.Addr(0),sizeof(Point3)*c,&nb);
	
	isave->EndChunk();


	return IO_OK;
}


IOResult VCPainter::LoadLocalData(ILoad *iload, LocalModData **pld)

{
	IOResult	res;
	ULONG		nb;

	VertexPaintData *bmd = new VertexPaintData();
	*pld = bmd;
	int ct = 0;
	while (IO_OK==(res=iload->OpenChunk())) {
		switch(iload->CurChunkID())  {


			case TVCOLOR_CHUNK: 
				{
				iload->Read(&ct,sizeof(ct),&nb);
				bmd->vertexPosList.SetCount(ct);
				iload->Read(bmd->vertexPosList.Addr(0),sizeof(Point3)*ct,&nb);

				iload->Read(&ct,sizeof(ct),&nb);
				bmd->faceList.SetCount(ct);
				iload->Read(bmd->faceList.Addr(0),sizeof(FaceData)*ct,&nb);

				iload->Read(&ct,sizeof(ct),&nb);
				bmd->vcColor.SetCount(ct);
				bmd->vcColorHold.SetCount(ct);
				iload->Read(bmd->vcColor.Addr(0),sizeof(Point3)*ct,&nb);


				break;
				}


			}
		iload->CloseChunk();
		if (res!=IO_OK) return res;
		}



return IO_OK;

}


void* VCPainter::GetInterface(ULONG id)

{
	
	switch(id)
	{
		case PAINTERCANVASINTERFACE_V5 : return (IPainterCanvasInterface_V5 *) this;
			break;
		default: return Modifier::GetInterface(id);
			break;
	}
	
}


BOOL  VCPainter::SystemEndPaintSession()
{
	if (painterProc) painterProc->SystemEndPaintSession();
	return TRUE;
}


int VCPainter::GetStrokeType()
{
pblock->GetValue(pb_stroketype,0,strokeType,FOREVER);
return strokeType;
}

int VCPainter::GetSampleRate()

{
	int sampleRate;
	pblock->GetValue(pb_samplerate,0,sampleRate,FOREVER);
	return sampleRate;
}

int VCPainter::GetGradient()

{
	int gradient;
	pblock->GetValue(pb_gradient,0,gradient,FOREVER);
	return gradient;
}

Texmap *VCPainter::GetGradientTex()

{
	Texmap *gradientTex;
	pblock->GetValue(pb_gradienttex,0,gradientTex,FOREVER);
	return gradientTex;
}
		

INode *VCPainter::GetNode()

{
	INode *node;
	pblock->GetValue(pb_spline,0,node,FOREVER);
	return node;
}

Point3 VCPainter::GetStrokeColor()

{
	Point3 c;
	pblock->GetValue(pb_color,0,c,FOREVER);
	return c;
}

void  VCPainter::HoldMap()
{
	if (!theHold.Holding()) 
		theHold.Begin();
	for (int i = 0; i < vmdList.Count(); i++)
		theHold.Put(new HoldVCRestore(this,vmdList[i]));

}