#include "PainterTextureSample.h"


HoldMapRestore::HoldMapRestore(PainterTextureSample *c) 
{
	tex = c;
//	ulowResMap = TheManager->NewBitmap();//(&tex->lowresBi);
//	uhiResMap = TheManager->NewBitmap();//(&tex->hiresBitmapPB->bi);
	BMM_Color_fl fillcolor;
	fillcolor.r = 0.0f;
	fillcolor.g = 0.0f;
	fillcolor.b = 0.0f;
	fillcolor.a = 0.0f;

	ulowResDIB = tex->bm->ToDib();
	uhiResDIB = tex->hiresBitmapPB->bm->ToDib();	
	redo = FALSE;
}   		

HoldMapRestore::~HoldMapRestore()
{
	LocalFree(ulowResDIB);
	LocalFree(uhiResDIB);	
	if (redo)
		{
		LocalFree(rlowResDIB);
		LocalFree(rhiResDIB);	
		}	

}

void HoldMapRestore::Restore(int isUndo) 
{
	if (isUndo) 
		{
		redo = TRUE;
		rlowResDIB = tex->bm->ToDib();
		rhiResDIB = tex->hiresBitmapPB->bm->ToDib();	
		
		}

	tex->bm->FromDib(ulowResDIB);
	tex->hiresBitmapPB->bm->FromDib(uhiResDIB);

	tex->texHandleValid.Empty();
	tex->DiscardTexHandle();
	tex->NotifyDependents(FOREVER, PART_TEXMAP, REFMSG_CHANGE);

	tex->NotifyDependents(FOREVER, PART_ALL, REFMSG_CHANGE);
	}
void HoldMapRestore::Redo()
	{
//watje 9-7-99  198721 
	tex->bm->FromDib(rlowResDIB);
	tex->hiresBitmapPB->bm->FromDib(rhiResDIB);

	tex->texHandleValid.Empty();
	tex->DiscardTexHandle();
	tex->NotifyDependents(FOREVER, PART_TEXMAP, REFMSG_CHANGE);


	tex->NotifyDependents(FOREVER, PART_ALL, REFMSG_CHANGE);

	}		

HoldVCRestore::HoldVCRestore(VCPainter *c,VertexPaintData *vmd) 
{
	mod = c;
	modData = vmd;
	uVC.SetCount(vmd->vcColor.Count());
	uVC = vmd->vcColor;
}   		


void HoldVCRestore::Restore(int isUndo) 
{
	if (isUndo) 
		{
		rVC.SetCount(modData->vcColor.Count());
		rVC = modData->vcColor;

		}

	modData->vcColor = uVC;
//watje 9-7-99  198721 
	mod->NotifyDependents(FOREVER, PART_ALL, REFMSG_CHANGE);
	}
void HoldVCRestore::Redo()
	{
//watje 9-7-99  198721 
	modData->vcColor = rVC;

	mod->NotifyDependents(FOREVER, PART_ALL, REFMSG_CHANGE);

	}		
